3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009,
8 # 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
9 # Originally by Gerald Pfeifer <gerald@pfeifer.com>, August 1998.
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
21 # If the first parameter reads --patch, the second parameter is considered
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
42 # Default options used when updating (none).
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
51 ######## Anything below shouldn't be changed by regular users.
53 # Arrange for the value of $0 to be available for functions
56 # This function prints its arguments to standard output unless
60 if [ -z "$silent" ]; then
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies
() {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
71 fixincludes
/configure
: fixincludes
/configure.ac fixincludes
/aclocal.
m4
72 fixincludes
/config.h.
in: fixincludes
/configure.ac fixincludes
/aclocal.
m4
74 intl
/plural.c
: intl
/plural.y
75 intl
/configure
: intl
/configure.ac intl
/aclocal.
m4
76 intl
/config.h.
in: intl
/configure.ac intl
/aclocal.
m4
77 # Now, proceed to gcc automatically generated files
78 gcc
/configure
: gcc
/configure.ac
79 gcc
/cstamp-h.
in: gcc
/configure.ac
80 gcc
/config.
in: gcc
/cstamp-h.
in
81 gcc
/fixinc
/fixincl.x
: gcc
/fixinc
/fixincl.tpl gcc
/fixinc
/inclhack.def
82 gcc
/config
/aarch64
/aarch64-tune.md
: gcc
/config
/aarch64
/aarch64-cores.def gcc
/config
/aarch64
/gentune.sh
83 gcc
/config
/arm
/arm-tune.md
: gcc
/config
/arm
/arm-cpus.
in gcc
/config
/arm
/parsecpu.
awk
84 gcc
/config
/arm
/arm-tables.opt
: gcc
/config
/arm
/arm-cpus.
in gcc
/config
/arm
/parsecpu.
awk
85 gcc
/config
/avr
/t-multilib
: gcc
/config
/avr
/avr-mcus.def gcc
/config
/avr
/genmultilib.
awk
86 gcc
/config
/c6x
/c6x-tables.opt
: gcc
/config
/c6x
/c6x-isas.def gcc
/config
/c6x
/genopt.sh
87 gcc
/config
/c6x
/c6x-sched.md
: gcc
/config
/c6x
/c6x-sched.md.
in gcc
/config
/c6x
/gensched.sh
88 gcc
/config
/c6x
/c6x-mult.md
: gcc
/config
/c6x
/c6x-mult.md.
in gcc
/config
/c6x
/genmult.sh
89 gcc
/config
/m68k
/m68k-tables.opt
: gcc
/config
/m68k
/m68k-devices.def gcc
/config
/m68k
/m68k-isas.def gcc
/config
/m68k
/m68k-microarchs.def gcc
/config
/m68k
/genopt.sh
90 gcc
/config
/mips
/mips-tables.opt
: gcc
/config
/mips
/mips-cpus.def gcc
/config
/mips
/genopt.sh
91 gcc
/config
/rs6000
/rs6000-tables.opt
: gcc
/config
/rs6000
/rs6000-cpus.def gcc
/config
/rs6000
/genopt.sh
92 gcc
/config
/tilegx
/mul-tables.c
: gcc
/config
/tilepro
/gen-mul-tables.cc
93 gcc
/config
/tilepro
/mul-tables.c
: gcc
/config
/tilepro
/gen-mul-tables.cc
94 # And then, language-specific files
95 gcc
/cp
/cfns.h
: gcc
/cp
/cfns.gperf
97 # Without this, _Pragma3.c can have a false negative.
98 gcc
/testsuite
/gcc.dg
/cpp
/_Pragma3.c
: gcc
/testsuite
/gcc.dg
/cpp
/mi1c.h
99 # Similarly, without this, you will see:
100 # direct2s.c:35: warning: current file is older than direct2.c
101 gcc
/testsuite
/gcc.dg
/cpp
/direct2s.c
: gcc
/testsuite
/gcc.dg
/cpp
/direct2.c
103 lto-plugin
/configure
: lto-plugin
/configure.ac lto-plugin
/aclocal.
m4
104 lto-plugin
/Makefile.
in: lto-plugin
/Makefile.am lto-plugin
/aclocal.
m4
105 # And libraries, at last
106 libbanshee
/configure
: libbanshee
/configure.ac
107 libmudflap
/configure
: libmudflap
/configure.ac
108 libobjc
/configure
: libobjc
/configure.ac
109 zlib
/aclocal.
m4: zlib
/configure.ac zlib
/acinclude.
m4
110 zlib
/Makefile.
in: zlib
/Makefile.am zlib
/configure.ac zlib
/aclocal.
m4
111 zlib
/configure
: zlib
/configure.ac zlib
/aclocal.
m4
112 fastjar
/aclocal.
m4: fastjar
/configure.ac
113 fastjar
/Makefile.
in: fastjar
/Makefile.am fastjar
/configure.ac fastjar
/aclocal.
m4
114 fastjar
/configure
: fastjar
/configure.ac fastjar
/aclocal.
m4
115 boehm-gc
/aclocal.
m4: boehm-gc
/configure.ac
116 boehm-gc
/Makefile.
in: boehm-gc
/Makefile.am boehm-gc
/configure.ac boehm-gc
/aclocal.
m4
117 boehm-gc
/configure
: boehm-gc
/configure.ac boehm-gc
/aclocal.
m4
118 libada
/configure
: libada
/configure.ac
119 libffi
/aclocal.
m4: libffi
/configure.ac libffi
/acinclude.
m4
120 libffi
/Makefile.
in: libffi
/Makefile.am libffi
/configure.ac libffi
/aclocal.
m4
121 libffi
/configure
: libffi
/configure.ac libffi
/aclocal.
m4
122 libffi
/fficonfig.h.
in: libffi
/configure.ac libffi
/aclocal.
m4
123 libgfortran
/aclocal.
m4: libgfortran
/configure.ac libgfortran
/acinclude.
m4
124 libgfortran
/Makefile.
in: libgfortran
/Makefile.am libgfortran
/configure.ac libgfortran
/aclocal.
m4
125 libquadmath
/configure
: libquadmath
/configure.ac libquadmath
/aclocal.
m4
126 libquadmath
/aclocal.
m4: libquadmath
/configure.ac libquadmath
/acinclude.
m4
127 libquadmath
/Makefile.
in: libquadmath
/Makefile.am libquadmath
/configure.ac libgfortran
/aclocal.
m4
128 libgfortran
/configure
: libgfortran
/configure.ac libgfortran
/aclocal.
m4
129 libcpp
/aclocal.
m4: libcpp
/configure.ac
130 libcpp
/Makefile.
in: libcpp
/configure.ac libcpp
/aclocal.
m4
131 libcpp
/configure
: libcpp
/configure.ac libcpp
/aclocal.
m4
132 libgomp
/aclocal.
m4: libgomp
/configure.ac libgomp
/acinclude.
m4
133 libgomp
/Makefile.am
: libgomp
/plugin
/Makefrag.am
134 libgomp
/Makefile.
in: libgomp
/Makefile.am libgomp
/aclocal.
m4
135 libgomp
/testsuite
/Makefile.
in: libgomp
/testsuite
/Makefile.am libgomp
/aclocal.
m4
136 libgomp
/configure.ac
: libgomp
/plugin
/configfrag.ac
137 libgomp
/configure
: libgomp
/configure.ac libgomp
/aclocal.
m4
138 libgomp
/config.h.
in: libgomp
/configure.ac libgomp
/aclocal.
m4
139 libhsail-rt
/aclocal.
m4: libhsail-rt
/configure.ac
140 libhsail-rt
/Makefile.
in: libhsail-rt
/Makefile.am libhsail-rt
/aclocal.
m4
141 libhsail-rt
/configure
: libhsail-rt
/configure.ac libhsail-rt
/aclocal.
m4
142 libhsail-rt
/target-config.h.
in: libhsail-rt
/configure.ac libhsail-rt
/aclocal.
m4
143 libitm
/aclocal.
m4: libitm
/configure.ac libitm
/acinclude.
m4
144 libitm
/Makefile.
in: libitm
/Makefile.am libitm
/aclocal.
m4
145 libitm
/testsuite
/Makefile.
in: libitm
/testsuite
/Makefile.am libitm
/aclocal.
m4
146 libitm
/configure
: libitm
/configure.ac libitm
/aclocal.
m4
147 libitm
/config.h.
in: libitm
/configure.ac libitm
/aclocal.
m4
148 libatomic
/aclocal.
m4: libatomic
/configure.ac libatomic
/acinclude.
m4
149 libatomic
/Makefile.
in: libatomic
/Makefile.am libatomic
/aclocal.
m4
150 libatomic
/testsuite
/Makefile.
in: libatomic
/testsuite
/Makefile.am libatomic
/aclocal.
m4
151 libatomic
/configure
: libatomic
/configure.ac libatomic
/aclocal.
m4
152 libatomic
/auto-config.h.
in: libatomic
/configure.ac libatomic
/aclocal.
m4
153 libsanitizer
/aclocal.
m4: libsanitizer
/configure.ac libsanitizer
/acinclude.
m4
154 libsanitizer
/Makefile.
in: libsanitizer
/Makefile.am libsanitizer
/aclocal.
m4
155 libsanitizer
/configure
: libsanitizer
/configure.ac libsanitizer
/aclocal.
m4
156 libsanitizer
/asan
/Makefile.
in: libsanitizer
/asan
/Makefile.am libsanitizer
/aclocal.
m4
157 libsanitizer
/interception
/Makefile.
in: libsanitizer
/interception
/Makefile.am libsanitizer
/aclocal.
m4
158 libsanitizer
/sanitizer_common
/Makefile.
in: libsanitizer
/sanitizer_common
/Makefile.am libsanitizer
/aclocal.
m4
159 libvtv
/aclocal.
m4: libvtv
/configure.ac libvtv
/acinclude.
m4
160 libvtv
/Makefile.
in: libvtv
/Makefile.am libvtv
/aclocal.
m4
161 libvtv
/configure
: libvtv
/configure.ac libvtv
/aclocal.
m4
162 libcilkrts
/aclocal.
m4: libcilkrts
/configure.ac
163 libcilkrts
/Makefile.
in: libcilkrts
/Makefile.am
164 libcilkrts
/configure
: libcilkrts
/configure.ac
165 liboffloadmic
/aclocal.
m4: liboffloadmic
/configure.ac
166 liboffloadmic
/Makefile.
in: liboffloadmic
/Makefile.am
167 liboffloadmic
/configure
: liboffloadmic
/configure.ac
168 liboffloadmic
/plugin
/aclocal.
m4: liboffloadmic
/plugin
/configure.ac
169 liboffloadmic
/plugin
/Makefile.
in: liboffloadmic
/plugin
/Makefile.am
170 liboffloadmic
/plugin
/configure
: liboffloadmic
/plugin
/configure.ac
172 Makefile.
in: Makefile.tpl Makefile.def
173 configure
: configure.ac config
/acx.
m4
178 # This function touches generated files such that the ``end'' user does
179 # not have to rebuild them.
182 echo 'all: \' > Makefile.$$
183 files_and_dependencies | sed 's
, .
*, \\,' >> Makefile.$$
184 echo '; @true
' >> Makefile.$$
185 files_and_dependencies | sed 's
, ,: ,' >> Makefile.$$
186 files_and_dependencies | sed 's
, .
*, \\,' >> Makefile.$$
187 echo ':' >> Makefile.$$
188 echo ' @
for f
in $? $@
; do test -f $
$f ||
exit 0; done; \' >> Makefile.$$
189 echo ' echo Touching $@...; \' >> Makefile.$$
190 chat ' echo Touching $@...
1>&2; \' >> Makefile.$$
191 echo ' touch $@' >> Makefile.$$
192 files_and_dependencies |
sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
194 # We would have to explicitly shut off the "Entering... Leaving..."
195 # messages through "--no-print-directory" to handle the case when
196 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
197 # Makefile, not just make). Passing only "-s" doesn't help then,
198 # because make has helpfully added "-w" to MAKEFLAGS automatically.
199 # Unfortunately we do not require GNU make other than for building
200 # and testing, so let's just grep known text explicitly echoed by
202 while ${MAKE-make} -s -f Makefile.$$ all |
grep Touching
> /dev
/null
; do
209 # Whenever we update the tree or install a patch, we may be modifying
210 # this script. By re-execing it, we ensure that the appropriate
211 # dependencies and rules will be used.
212 touch_files_reexec
() {
213 chat
"Adjusting file timestamps"
214 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
217 # This functions applies a patch to an existing tree.
220 echo "Applying patch file $1"
223 gzip -d -c "$1" |
patch -p1 ;;
225 bzip2 -d -c "$1" |
patch -p1 ;;
233 # Check whether this indeed looks like a local tree.
234 if [ ! -f gcc
/version.c
]; then
235 echo "This does not seem to be a GCC tree!"
247 # First of all, check whether we are going to process a patch.
249 if test "$#" != 2; then
250 echo "$1" expects only one argument
>&2
258 if test "$#" != 1; then
259 echo "$1" does not expect any argument
>&2
267 if test "$#" != 1; then
268 echo "$1" does not expect any argument
>&2
271 files_and_dependencies |
sed 's/ /: /'
276 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
281 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
287 # Check for known version control systems.
289 GCC_GIT
=${GCC_GIT-${GIT-git}}
291 elif [ -d .hg
]; then
292 GCC_HG
=${GCC_HG-${HG-hg}}
294 elif [ -d .svn
]; then
295 GCC_SVN
=${GCC_SVN-${SVN-svn}}
298 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
302 # Check command-line options
303 if [ x
"${1}"x
= x
"--nostdflags"x
]; then
306 set -- $UPDATE_OPTIONS ${1+"$@"}
311 chat
"Updating GIT tree"
313 $GCC_GIT diff --quiet --exit-code HEAD
314 if [ $?
-ne 0 ]; then
315 echo "Attempting to update a dirty git tree!" >&2
316 echo "Commit or stash your changes first and retry." >&2
320 $GCC_GIT pull
${silent+-q} --rebase ${1+"$@"}
321 if [ $?
-ne 0 ]; then
323 echo "git pull of full tree failed." >&2
327 revision
=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
328 branch
=`$GCC_GIT name-rev --name-only HEAD || :`
332 chat
"Updating HG tree"
334 # Add -q so untracked files aren't listed.
335 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
336 echo "Attempting to update a dirty hg tree!" >&2
337 echo "Commit or revert your changes first and retry." >&2
341 # Check for mq extension. mq patches must be popped so tip has
342 # been converted from the SVN tree.
343 if [ -d .hg
/patches
] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
344 # FIXME: Perhaps pop queue instead? We could do that since we
345 # know the tree is clean.
346 echo "Attempting to update hg tree with mq patches applied!" >&2
347 echo "Pop your patches first and retry." >&2
351 # Update tree, but make sure to only pull the default branch.
352 # Otherwise all branches in the upstream repo are added, even if
353 # only a single one has been cloned.
354 $GCC_HG pull
${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
355 if [ $?
-ne 0 ]; then
357 echo "hg pull of full tree failed." >&2
361 # Update tree. Needs to be done separately from pull so
362 # gcc_update -rREV works.
363 $GCC_HG update
${silent+-q} ${1+"$@"}
364 if [ $?
-ne 0 ]; then
366 echo "hg update of full tree failed." >&2
370 # Extract SVN revision corresponding to parents, as stored by
371 # hg convert. Before hg 1.4.3, there's no template keyword
372 # corresponding to the extra: tag, so need to use hg log --debug
373 # to extract the info.
374 parents
=`$GCC_HG parents --template '{rev}'`
375 convert_revision
=`$GCC_HG log --debug -r$parents | \
376 sed -ne "/^extra:.*convert_revision=svn:/ {
380 revision
=`echo $convert_revision | sed -e 's/.*@//'`
381 branch
=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
385 chat
"Updating SVN tree"
387 $GCC_SVN ${silent+-q} --non-interactive update
${1+"$@"}
388 if [ $?
-ne 0 ]; then
390 echo "SVN update of full tree failed." >&2
394 revision
=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
395 branch
=`$GCC_SVN info | sed -ne "/^URL:/ {
404 rm -f LAST_UPDATED gcc
/REVISION
407 echo "`TZ=UTC date` (revision $revision)"
409 echo "[$branch revision $revision]" > gcc
/REVISION